﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Caching;

namespace testCache
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        MemoryCache cache = null;

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            // 注意：
            // 名称引用配置文件中定义的名字
            // 如果找不到，就会填充默认值
            cache = new MemoryCache("cat"); //实例化

            // 输出调试信息
            System.Diagnostics.Debug.WriteLine("MemoryCache 实例的属性：\n" +
                $"{nameof(MemoryCache.Name)} = {cache.Name}\n" +
                $"{nameof(MemoryCache.CacheMemoryLimit)} = {cache.CacheMemoryLimit / 1024 / 1024} Mb\n" +
                $"{nameof(MemoryCache.PhysicalMemoryLimit)} = {cache.PhysicalMemoryLimit} %\n" +
                $"{nameof(MemoryCache.PollingInterval)} = {cache.PollingInterval:t}");
        }
        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            base.OnFormClosing(e);
            cache?.Dispose(); //释放资源
            cache = null;
        }

        Random rand = new Random();
        private void button1_Click(object sender, EventArgs e)
        {
            if (cache.Contains("item"))
            {
                int v = Convert.ToInt32(cache["item"]); //读缓存
                label1.Text = v.ToString();
            }
            else
            {
                int v = rand.Next(0, 1000); //生成随机数
                // 写入缓存
                cache.Set("item", v, DateTimeOffset.Now.AddSeconds(5));
                label1.Text = v.ToString();
            }
        }
    }
}
